質問をすることでしか得られない、回答やアドバイスがある。

15分調べてもわからないことは、質問しよう!

ただいまの
回答率

90.75%

  • Swift

    6684questions

    Swiftは、アップルのiOSおよびOS Xのためのプログラミング言語で、Objective-CやObjective-C++と共存することが意図されています

Swiftのヴァージョンアップは、それに合わせて都度対応しておくものなのでしょうか?それともある程度はしょって対応することもあるものなのでしょうか?

解決済

回答 2

投稿

  • 評価
  • クリップ 2
  • VIEW 426

desafinado

score 2

開発会社において、iOS対応のアプリについて、Swiftのヴァージョンアップは、それに合わせて都度対応しておくものなのでしょうか?それともある程度はしょって対応することもあるものなのでしょうか?

今回、開発会社に開発を依頼したアプリについて、「Swift 2.3から4.0」への対応が必要との事でかなりの金額を請求されたのですが、以下のサイトを見ると、「Swift 3.2から4.0」への対応は、以下のツールが使え「3.2モードでは3系のコンパイラで構築したソースのほとんどをそのままコンパイルでき、以前から存在していたAPIをそのまま利用できるという。」とあるので、3.2に対応しておけばこのような事にならなかったのではないかと考えています。

アプリの規模や契約などにも拠るのかもしれませんが、色々な意見を頂けると助かります。

ご意見をお待ちしております。

「新たな機能として、古いコードを修正無しにコンパイルできる「互換性モード」が導入された。「-swift-version」フラグで互換性に関する設定が行えるもので、Swift 4.0ではSwift 3.2およびSwift 4.0の2つのモードがサポートされる。3.2モードでは3系のコンパイラで構築したソースのほとんどをそのままコンパイルでき、以前から存在していたAPIをそのまま利用できるという。また、このモードでもSwift 4で導入された新しい言語機能のほとんどが使えるという。いっぽう4.0モードでは言語およびAPIに変更が加えられていることから、一部のソースは修正する必要がある可能性が多いとしている。」

  • 気になる質問をクリップする

    クリップした質問は、後からいつでもマイページで確認できます。

    またクリップした質問に回答があった際、通知やメールを受け取ることができます。

    クリップを取り消します

  • 良い質問の評価を上げる

    以下のような質問は評価を上げましょう

    • 質問内容が明確
    • 自分も答えを知りたい
    • 質問者以外のユーザにも役立つ

    評価が高い質問は、TOPページの「注目」タブのフィードに表示されやすくなります。

    質問の評価を上げたことを取り消します

  • 評価を下げられる数の上限に達しました

    評価を下げることができません

    • 1日5回まで評価を下げられます
    • 1日に1ユーザに対して2回まで評価を下げられます

    質問の評価を下げる

    teratailでは下記のような質問を「具体的に困っていることがない質問」、「サイトポリシーに違反する質問」と定義し、推奨していません。

    • プログラミングに関係のない質問
    • やってほしいことだけを記載した丸投げの質問
    • 問題・課題が含まれていない質問
    • 意図的に内容が抹消された質問
    • 広告と受け取られるような投稿

    評価が下がると、TOPページの「アクティブ」「注目」タブのフィードに表示されにくくなります。

    質問の評価を下げたことを取り消します

    この機能は開放されていません

    評価を下げる条件を満たしてません

    評価を下げる理由を選択してください

    詳細な説明はこちら

    上記に当てはまらず、質問内容が明確になっていない質問には「情報の追加・修正依頼」機能からコメントをしてください。

    質問の評価を下げる機能の利用条件

    この機能を利用するためには、以下の事項を行う必要があります。

質問への追記・修正、ベストアンサー選択の依頼

  • xAxis

    2017/11/17 19:06

    ソースってこれです?https://mag.osdn.jp/17/09/22/171000

    キャンセル

  • desafinado

    2017/11/17 19:07

    はい、そうです。

    キャンセル

回答 2

+5

3.2に対応しておけばこのような事にならなかったのではないかと考えています。

その時にお金取られるから同じことでは?

投稿

  • 回答の評価を上げる

    以下のような回答は評価を上げましょう

    • 正しい回答
    • わかりやすい回答
    • ためになる回答

    評価が高い回答ほどページの上位に表示されます。

  • 回答の評価を下げる

    下記のような回答は推奨されていません。

    • 間違っている回答
    • 質問の回答になっていない投稿
    • スパムや攻撃的な表現を用いた投稿

    評価を下げる際はその理由を明確に伝え、適切な回答に修正してもらいましょう。

  • 2017/11/20 17:32

    おっしゃる通りです。

    キャンセル

checkベストアンサー

+2

  1. 都度バージョンアップの要否

都度のバージョンアップは推奨しますが必須ではないと考えます。
しかし、間隔が開けば開くほど工数はかかります。

常にリリースできる状態で機能追加していくアジャイル開発をしているのであれば、都度バージョンアップしたほうがコストは安そうです。

開発する機能をいくつかまとめて請負等で他社にお願いする場合は、都度のバージョンアップはコストに合わないかもしれません。
その場合の観点は新旧機能が使えるか、AppStoreに出せるか、などがあります。
(1)新旧機能が使えるか
Swift2.3が使用できるのはXCode8.2までです。
XCode8.3以降で提供されている機能を使用するためにはSwift3以降にする必要があります。
また、現在使用しているライブラリがSwift3では動作しないなどがある場合はアップデートに慎重になったほうが良いです。

(2)AppStoreに出せるか
AppStoreに提出するアプリの場合、審査基準にiOS10.3(XCode8.3)以降に最適化されたアプリを出すことが追加されたらSwift3以降で書くことが必須となります。
これはAppleが審査基準について定期的にアナウンスしているのでウォッチする必要があります。
過去にもURConnectionを使用しているアプリはリジェクト対象になったり、ATSに対応していないアプリはリジェクト対象になると宣言したりと開発者を困らせた事例があります。
なお、iPhoneXの発表により変更されたデザインガイドラインを守っていないとリジェクト対象になる可能性がありますのでご注意ください。

Appleの発表を確認してXCodeのβ版が出たら検証するなど、移行の有無を検討ください。

  1. バージョンアップの難易度

個人的所感ですが、Swift3⇒Swift4は使用している機能によってたまたまなのか移行はあっさりできました。
自分はSwift3以降からの開発者なので経験はありませんが、Swift2.3⇒Swift3の難易度が高いのだと考えます。
以下、ブログ等で観測できる事例を紹介します。

Swift2.2 -> Swift3.0 への移行が辛すぎてプロジェクトを作り直した話
Swift2.2 から Swift3 へ頑張って移行した話
Swift2.2 から Swift3.0 への変換実例メモ
Xcode 8でswift3への移行するポイントまとめ

  1. Swiftを使わないという選択肢

知人のことですが、Swiftの変更についていくのが嫌になり全てObjective-Cで開発するという選択肢を取った人もいます。
ただし、今後はSwiftが主流になると思いますので、他社へ発注するなどになるとObjective-Cの開発者が確保できない場合もあります。
その他、AndroidとiOSのクロスプラットフォーム開発をしている場合はKotlin、Xamarin、CordovaなどでのiOSアプリ開発という選択肢もあるかもしれません。しかし、すでにiOS公式言語で開発していたものを別言語で開発するのはコストやリスクについて十分な検討が必要です。

投稿

  • 回答の評価を上げる

    以下のような回答は評価を上げましょう

    • 正しい回答
    • わかりやすい回答
    • ためになる回答

    評価が高い回答ほどページの上位に表示されます。

  • 回答の評価を下げる

    下記のような回答は推奨されていません。

    • 間違っている回答
    • 質問の回答になっていない投稿
    • スパムや攻撃的な表現を用いた投稿

    評価を下げる際はその理由を明確に伝え、適切な回答に修正してもらいましょう。

  • 2017/11/20 17:32

    とても参考になりました。今回は「Swift 2.3から4.0」だったのですが、「Swift2.3⇒Swift3の難易度が高い」ということがネックになっているのが分かりました。開発会社の対応が遅れて、アプリが一時期動かなくなってしまうなど後手後手だった点も、不信感を抱いてしまう要因になりました。

    キャンセル

15分調べてもわからないことは、teratailで質問しよう!

  • ただいまの回答率 90.75%
  • 質問をまとめることで、思考を整理して素早く解決
  • テンプレート機能で、簡単に質問をまとめられる

関連した質問

同じタグがついた質問を見る

  • Swift

    6684questions

    Swiftは、アップルのiOSおよびOS Xのためのプログラミング言語で、Objective-CやObjective-C++と共存することが意図されています

  • トップ
  • Swiftに関する質問
  • Swiftのヴァージョンアップは、それに合わせて都度対応しておくものなのでしょうか?それともある程度はしょって対応することもあるものなのでしょうか?